/*
 arcman - wii .arc file manager

 (c) JoeBlob

------------------------------------------------------------------------

*/


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <direct.h>

#include "arc.h"


static int main(int argc, char* argv[])
{
	ARC_FILE *af;
	ARC_FST_ENTRY *entry;
	unsigned int maxentries;
	register unsigned int info;
	unsigned int i;
	ARC_ENTRY_DATA ed;
	int n;
	FILE *f;
	void *buffer;
	int inroot = 0;
	char *name;

	if( argc < 2 )
	{
		printf("Wii arc manager 0.2a\n"
			   "All rights reversed, (c) JoeBlob\n"
			   "usage: arcman <file.arc>\n");
		return 1;
	}

	af = arc_open( argv[1] );
	if( af == NULL )
	{
		printf("- invalid archive.\n");
		return 1;
	}

	printf("- archive successfully opened.\n");

	if( (maxentries = arc_get_entry_count( af ) ) == 0 )
	{
		arc_close( af );
		printf("- empty archive.\n");
		return 1;
	}
	printf("- displaying content (%d entries):\n\n", maxentries);

	if( (n = arc_find_first( af, &ed ) ) == 0 )
	{
		arc_close( af );
		printf("- error finding file.\n");
		return 1;
	}

	do
	{
		printf("[%s] offs[0x%08X] len[%08d] %s\n", ed.type == 0?"-":"d", ed.file_offset, ed.data_size, ed.name );
		switch( ed.type )
		{
		case 0:
			{
				f = fopen( ed.name, "wb" );
				if( f == NULL )
					break;
				buffer = malloc( ed.data_size );
				if( buffer == NULL )
				{
					fclose( f );
					break;
				}
				if( arc_get_file_content( af, ed.file_offset, ed.data_size, buffer ) )
				{
					fwrite( buffer, ed.data_size, 1, f );
				}
				fclose( f );
				free( f );
				break;
			}
		case 1:
			{
				if( ed.file_offset == 0 )
				{
					mkdir( "arc" );
					chdir( "arc" );
				}
				else // if( ed.file_offset == 1 )
				{
					mkdir( ed.name );
					chdir( ed.name );
				}
				break;
			}
		}
	}
	while( (n = arc_find_next( af, n, &ed ) ) != 0 );


	printf("\n- end of archive.\n");

	arc_close( af );

	return 0;
}




